<template>
  <div>
    <div class="title">Укажите новый номер заказа клиента</div>
    <div class="row">
      <div class="col-xs-6">
        <ObInput
          label="Старый номер заказа клиента"
          :value="formData.oldNumber || 'Не указан'"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          v-model="formData.newNumber"
          label="Новый номер заказа клиента"
          placeholder="Введите номер"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ObTextarea
          :value="formData.comment"
          label="Комментарий"
          placeholder="Добавьте комментарий"
          :readonly="(!isNew && !isEditable)"
          @input="onChangeField('comment', $event)"
        />
      </div>
    </div>
    <template v-if="((!formData.fileUuids || !formData.fileUuids.length) && !isNew && !isEditable)">
      <div class="title">Нет прикрепленных файлов</div>
    </template>
    <template v-else>
      <div class="title">Прикрепленные файлы</div>
      <ObUploader
        ref="uploader"
        multiple
        :value="currentFile"
        data-qa="uploader"
        :is-read-only="(!isNew && !isEditable)"
        :upload-method="uploadMethod"
        @process-start="startUploadFiles"
        @change="onUploadHandler"
      />
    </template>
  </div>
</template>

<script>
import api from "@/api"
import ObInput from 'common-components/src/obComponents/obInput'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObUploader from 'common-components/src/obComponents/obUploader'

export default {
  name: 'externalNumberEventForm',
  components: {
    ObInput,
    ObTextarea,
    ObUploader
  },
  props: {
    formData: {
      type: Object,
      default: () => {}
    },
    order: {
      type: Object,
      default: () => {}
    },
    isEditable: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      selectedUser: {}
    }
  },
  watch: {
    'formData.fileUuids': {
      handler (value) {
        if (!value) {
          this.$refs.uploader && this.$refs.uploader.clearFiles()
        }
      },
      deep: true
    }
  },
  computed: {
    isNew () {
      return Boolean(!this.formData.uuid)
    },
    uploadMethod () {
      return api.files.postFile
    },
    currentFile () {
      if (this.formData.fileUuids && this.formData.fileUuids !== 'loading') {
        return this.formData.fileUuids.map((uuid) => {
          return { uuid: uuid }
        })
      }

      return null
    }
  },
  methods: {
    startUploadFiles () {
      this.formData.fileUuids = 'loading'
    },
    async onUploadHandler (data) {
      data = data.map(file => file.uuid)

      this.onChangeField('fileUuids', data)
    },
    onChangeField (path, value) {
      this.$emit('change-field', { path, value })
    }
  }
}
</script>